=== modified file 'drizzled/dynamic_array.cc'
--- drizzled/dynamic_array.cc	2011-03-01 18:19:16 +0000
+++ drizzled/dynamic_array.cc	2011-03-01 18:51:28 +0000
@@ -93,26 +93,22 @@
     false	Ok
 */
 
-bool insert_dynamic(DYNAMIC_ARRAY *array, unsigned char* element)
+static void insert_dynamic(DYNAMIC_ARRAY *array, void* element)
 {
   unsigned char* buffer;
   if (array->elements == array->max_element)
-  {						/* Call only when nessesary */
-    if (!(buffer=alloc_dynamic(array)))
-      return true;
-  }
+    buffer= alloc_dynamic(array);
   else
   {
-    buffer=array->buffer+(array->elements * array->size_of_element);
+    buffer= array->buffer+(array->elements * array->size_of_element);
     array->elements++;
   }
-  memcpy(buffer,element,(size_t) array->size_of_element);
-  return false;
+  memcpy(buffer,element, array->size_of_element);
 }
 
 void DYNAMIC_ARRAY::push_back(void* v)
 {
-  insert_dynamic(this, (unsigned char*)v);
+  insert_dynamic(this, v);
 }
 
 

=== modified file 'drizzled/dynamic_array.h'
--- drizzled/dynamic_array.h	2011-03-01 18:19:16 +0000
+++ drizzled/dynamic_array.h	2011-03-01 18:51:28 +0000
@@ -51,7 +51,6 @@
 /* init_dynamic_array() function is deprecated */
 bool init_dynamic_array(DYNAMIC_ARRAY *array,uint32_t element_size,
                                   uint32_t init_alloc,uint32_t alloc_increment);
-bool insert_dynamic(DYNAMIC_ARRAY *array,unsigned char * element);
 unsigned char *alloc_dynamic(DYNAMIC_ARRAY *array);
 unsigned char *pop_dynamic(DYNAMIC_ARRAY*);
 bool set_dynamic(DYNAMIC_ARRAY *array,unsigned char * element,uint32_t array_index);
@@ -60,9 +59,6 @@
 void delete_dynamic_element(DYNAMIC_ARRAY *array, uint32_t array_index);
 void freeze_size(DYNAMIC_ARRAY *array);
 int  get_index_dynamic(DYNAMIC_ARRAY *array, unsigned char * element);
-#define dynamic_element(array,array_index,type) ((type)((array)->buffer) +(array_index))
-#define push_dynamic(A,B) insert_dynamic((A),(B))
-#define reset_dynamic(array) ((array)->elements= 0)
 #define sort_dynamic(A,cmp) my_qsort((A)->buffer, (A)->elements, (A)->size_of_element, (cmp))
 
 } /* namespace drizzled */

=== modified file 'drizzled/internal/default.cc' (properties changed: +x to -x)
--- drizzled/internal/default.cc	2011-02-17 00:14:13 +0000
+++ drizzled/internal/default.cc	2011-03-01 18:51:28 +0000
@@ -292,8 +292,7 @@
   {
     if (!(tmp= (char *)ctx->alloc->alloc_root(strlen(option) + 1)))
       return 1;
-    if (insert_dynamic(ctx->args, (unsigned char*) &tmp))
-      return 1;
+    ctx->args->push_back(&tmp);
     strcpy(tmp, option);
   }
 

=== modified file 'drizzled/my_hash.cc'
--- drizzled/my_hash.cc	2011-02-17 00:14:13 +0000
+++ drizzled/my_hash.cc	2011-03-01 18:51:28 +0000
@@ -58,6 +58,8 @@
   return nr1;
 }
 
+#define dynamic_element(array,array_index,type) ((type)((array)->buffer) +(array_index))
+
 bool
 _hash_init(HASH *hash,uint32_t growth_size, const CHARSET_INFO * const charset,
            uint32_t size, size_t key_offset, size_t key_length,

=== modified file 'drizzled/optimizer/key_field.cc'
--- drizzled/optimizer/key_field.cc	2011-02-24 19:13:33 +0000
+++ drizzled/optimizer/key_field.cc	2011-03-01 18:51:28 +0000
@@ -65,7 +65,7 @@
                                    0,
                                    key_field->rejectNullValues(),
                                    key_field->getConditionalGuard());
-          insert_dynamic(keyuse_array, (unsigned char*) &keyuse);
+          keyuse_array->push_back(&keyuse);
         }
       }
     }

=== modified file 'drizzled/optimizer/range.cc'
--- drizzled/optimizer/range.cc	2011-02-24 18:16:42 +0000
+++ drizzled/optimizer/range.cc	2011-03-01 18:51:28 +0000
@@ -4169,10 +4169,7 @@
   set_if_bigger(quick->max_used_key_length, (uint32_t)range->min_length);
   set_if_bigger(quick->max_used_key_length, (uint32_t)range->max_length);
   set_if_bigger(quick->used_key_parts, (uint32_t) key_tree->part+1);
-  if (insert_dynamic(&quick->ranges, (unsigned char*) &range))
-  {
-    return 1;
-  }
+  quick->ranges.push_back(&range);
 
  end:
   if (key_tree->right != &optimizer::null_element)
@@ -4296,8 +4293,7 @@
     key_part->null_bit=     key_info->key_part[part].null_bit;
     key_part->flag=         (uint8_t) key_info->key_part[part].key_part_flag;
   }
-  if (insert_dynamic(&quick->ranges,(unsigned char*)&range))
-    goto err;
+  quick->ranges.push_back(&range);
 
   /*
      Add a NULL range if REF_OR_NULL optimization is used.
@@ -4317,8 +4313,7 @@
                                  make_prev_keypart_map(ref->key_parts), EQ_RANGE)))
       goto err;
     *ref->null_ref_key= 0;		// Clear null byte
-    if (insert_dynamic(&quick->ranges,(unsigned char*)&null_range))
-      goto err;
+    quick->ranges.push_back(&null_range);
   }
 
   /* Call multi_range_read_info() to get the MRR flags and buffer size */

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2011-03-01 18:19:16 +0000
+++ drizzled/sql_select.cc	2011-03-01 18:51:28 +0000
@@ -647,7 +647,7 @@
                        (qsort_cmp) sort_keyuse);
 
     memset(&key_end, 0, sizeof(key_end)); /* Add for easy testing */
-    insert_dynamic(keyuse,(unsigned char*) &key_end);
+    keyuse->push_back(&key_end);
 
     use= save_pos= (optimizer::KeyUse*)keyuse->buffer;
     prev= &key_end;

